' ChkDefaultPose
'          

function XSILoadPlugin( in_reg )
    in_reg.Author = "Nuenaka"
    in_reg.Name = "ChkDefaultPose Plug-in"
    in_reg.Major = 1
    in_reg.Minor = 1
    in_reg.RegisterCommand "ChkDefaultPose","ChkDefaultPose"
    XSILoadPlugin = true
end function

function ChkDefaultPose_Init( io_Context )
    dim oCmd
    set oCmd = io_Context.Source
'   Application.LogMessage "ChkDefaultPose_Init called"
    oCmd.Description = "Check neutral pose, pivot, compensation are default."
    oCmd.ToolTip = ""
    oCmd.SetFlag siSupportsKeyAssignment
    oCmd.ReturnValue = false
    ChkDefaultPose_Init = true
end function

function addObjs( objs, oObj )
    for each s in objs
        if s = oObj then
            exit function
        end if
    next
    objs.add oObj
end function

function chkPose( objs, oObj, kine, str, errmes, val )
    dim v1
    v1 = kine.Parameters( str ).value
    if v1 <> val then
        logmessage oObj & " : " & errmes & " is " & v1
        addObjs objs, oObj
        exit function
    end if
    ' logmessage oObj & " : " & errmes & " is OK, " & v1
end function

function chkPoseAtr( objs, oObj, kine, str, errmes, val )
    chkPose objs, oObj, kine, str & "x", errmes & " X", val
    chkPose objs, oObj, kine, str & "y", errmes & " Y", val
    chkPose objs, oObj, kine, str & "z", errmes & " Z", val
end function

function chkDefaultPoseOne( objs, oObj )
    dim k
    set k = oObj.Kinematics.Local
    chkPoseAtr objs, oObj, k, "nscl", "Neutral pose scaling", 1.0
    chkPoseAtr objs, oObj, k, "nrot", "Neutral pose rotation", 0.0
    chkPoseAtr objs, oObj, k, "npos", "Neutral pose position", 0.0
    chkPoseAtr objs, oObj, k, "nsclori", "Neutral pose scaling orientation", 0.0

    chkPoseAtr objs, oObj, k, "pscl", "Pivot scaling", 1.0
    chkPoseAtr objs, oObj, k, "prot", "Pivot rotation", 0.0
    chkPoseAtr objs, oObj, k, "ppos", "Pivot position", 0.0

    chkPoseAtr objs, oObj, k, "pcscl", "Compensation scaling", 1.0
    chkPoseAtr objs, oObj, k, "pcrot", "Compensation rotation", 0.0
    chkPoseAtr objs, oObj, k, "pcpos", "Compensation position", 0.0
   
end function

sub ChkDefaultPose_Execute(  )
'   Application.LogMessage "ChkDefaultPose_Execute called"

	dim tpc
	tpc = TechPluginCertification( "ChkDefaultPose", "1.1" )
	if tpc <> True then
		' false ɂƗvȂG[bZ[Wô true ƂB
        exit sub
	end if

    logmessage "ChkDefaultPose start...."
    if selection.Count = 0 then
        logmessage "Please select object(s)."
        exit sub
    end if
    
    dim objs
    set objs = CreateObject( "XSI.Collection" )
    dim oObj
    for each oObj in selection
        chkDefaultPoseOne objs, oObj
    next
    if objs.Count = 0 then
        logmessage "ALL OK!"
    end if
    SelectObj objs
end sub
